<?php
/**
* @copyright	Copyright (C) 2009 - 2009 Ready Bytes Software Labs Pvt. Ltd. All rights reserved.
* @license		GNU/GPL, see LICENSE.php
* @package		PayPlans
* @subpackage	NINJABOARD
* @contact 		shyam@readybytes.in
* 
*/
if(defined('_JEXEC')===false) die();

class PayplansAppNinjaboard extends PayplansApp
{
	protected $_location	= __FILE__;
	
    // applicable only if ninjaboard component exist
	public function _isApplicable(PayplansIfaceApptriggerable $refObject, $eventname='')
	{
		return JFolder::exists(JPATH_SITE .DS.'components'.DS.'com_ninjaboard');
	}

    public function onPayplansSubscriptionAfterSave($prev, $new)
	{
		// no need to trigger if previous and current state is same
		if($prev != null && $prev->getStatus() == $new->getStatus()){
			return true;
		}

	    $userid = $new->getBuyer();
	   
	    //Is user Admin/SuperAdmin then do nothing
	   	if(PayplansUser::getInstance($userid)->isAdmin()){
			return true;
		 }
	   
        //on Subscription Active 
		if($new->getStatus() == PayplansStatus::SUBSCRIPTION_ACTIVE){
		   $addToUsrgrp = $this->getAppParam('addToUsrgrponActive');
		   return $this->_addToNinjaGroup($userid, $addToUsrgrp);
		}

		//on Subscription Expired	
	    if($new->getStatus() == PayplansStatus::SUBSCRIPTION_EXPIRED){
		   $addToUsrgrp = $this->getAppParam('addToUsrgrponExpire');
		   return  $this->_addToNinjaGroup($userid, $addToUsrgrp);
		}

        // on Subscription Hold
	    if($new->getStatus() == PayplansStatus::SUBSCRIPTION_HOLD){
		   $addToUsrgrp = $this->getAppParam('addToUsrgrponHold');
		   return  $this->_addToNinjaGroup($userid, $addToUsrgrp);	
		}
		return true;
	}
    
	function _addToNinjaGroup($userid, $addToNinjagrp)
    {
    	$db 	= XiFactory::getDBO();
    	$query  = ' SELECT * '
    	          .' FROM #__ninjaboard_user_group_maps '
    	          .' WHERE `joomla_user_id` = "'.$userid.'"';
    	
    	$db->setQuery( $query );
    	$result =$db->loadResult();
        //if already entry in the table then update it otherwise made new entry
        if(isset($result)){
	    	$query  = 'UPDATE #__ninjaboard_user_group_maps'
	    		 	 .' SET `ninjaboard_user_group_id` ='.$addToNinjagrp.
   	      		 ' WHERE `joomla_user_id` = "'.$userid.'"';
    	}
     	else{ 
	     	$query  = 'INSERT INTO #__ninjaboard_user_group_maps'
	     	           .' VALUES("'.$userid.'","'.$addToNinjagrp.'")';
     	}
  
     	$db->setQuery( $query );
     	$db->query();
        return true;
    }
    
    //render Widget
	public function renderWidgetHtml()
	{   
		//get user id
		$userid      = XiFactory::getUser()->id;
		//get user's Ninja group
	    $ninja_group = $this->_getUserNinjaGroup($userid);
		if(empty($ninja_group)){
	    	return '';
	    }
	    $this->assign('ninjaboard_group',$ninja_group);
        $data        = $this->_render('widgethtml');
        return $data;
	}

	protected function _getUserNinjaGroup($userid)
	{
		$db 	     = XiFactory::getDBO();
		$query       = 'SELECT `title`'
			           . ' FROM #__ninjaboard_user_groups AS Groups, #__ninjaboard_user_group_maps AS UserGroupMaps'
			           . ' WHERE `joomla_user_id` = " ' . $userid . ' "'
			           . ' AND Groups.`ninjaboard_user_group_id` = UserGroupMaps.`ninjaboard_user_group_id`';
		$db->setQuery( $query );	
        $ninjaGroup  = $db->loadResult();
        return $ninjaGroup;
	}
}

